#!/bin/bash
#PBS -N stargengenomePlzen1
#PBS -l select=1:ncpus=24:mem=32gb:scratch_local=128gb
#PBS -j oe
#PBS -m e
#PBS -l walltime=24:00:00

#The first draft of the script was created by P. Ryšavý, the supervisor of this thesis, further modifications were made by H. Mertanová.

trap 'clean_scratch' TERM EXIT

# get info about the machine
cat /proc/cpuinfo | grep '^model name' | sort -u

# runs STAR aligner to generate reference for the genome

DATADIR=/storage/plzen1/home/mertahan/fa/ref #change to your path to reference files 
						#(Homo_sapiens.GRCh38.dna_sm.primary_assembly.fa.gz and .gtf)

# copy all the data to scratch
cp $DATADIR/Homo_sapiens.GRCh38.dna_sm.primary_assembly.fa.gz $SCRATCHDIR || exit 1

cd $SCRATCHDIR || exit 1

gunzip Homo_sapiens.GRCh38.dna_sm.primary_assembly.fa.gz

echo "unzip ref"

# run star to generate genome
/storage/plzen1/home/mertahan/progs/STAR --runThreadN 24 --runMode genomeGenerate --genomeDir ./ --genomeFastaFiles Homo_sapiens.GRCh38.dna_sm.primary_assembly.fa --outTmpDir tmp #change path to STAR

echo "star"
ls

# do not copy the reference
rm Homo_sapiens.GRCh38.dna_sm.primary_assembly.fa
rm Homo_sapiens.GRCh38.dna_sm.primary_assembly.fa.gz

# now copy everything to the storage
cp -r * $DATADIR || exit 1
rm -r *

echo "done"
