import pickle

from sklearn.cluster import DBSCAN
import numpy as np
import pickle

from sklearn.cluster import AgglomerativeClustering
import random
import matplotlib
import os
import matplotlib as mpl
mpl.use('Agg')
from matplotlib import pyplot as plt

from sklearn.decomposition import PCA

def isOut(x, mean, sd):
    return x < mean - 3*sd or x > mean + 3*sd

remOut = True
local = True
P = 2 #PCA

rangestart = 2
rangeend = 19

resu = [d  for d in os.listdir() if d[0:3] == 'res' and os.path.isdir(d)]

for d in resu:


    file2 = open(d + '/plot.pkl', 'rb')
    new_d = pickle.load(file2)
    file2.close()

    X = new_d[0]
    lab = new_d[1]



    colorsm = ['r', 'g', 'b', 'y', 'm', 'lawngreen', 'aqua', 'navy', ] + ['chartreuse', 'darkslategrey', 'lavender', 'floralwhite', 'powderblue', 'deepskyblue', 'violet', 'skyblue', 'peru', 'gainsboro', 'dodgerblue', 'darkblue', 'mediumpurple', 'darkgray', 'lightsteelblue', 'lavenderblush', 'turquoise', 'darkslateblue', 'forestgreen', 'steelblue', 'blanchedalmond', 'azure', 'saddlebrown', 'lightgreen', 'orange', 'springgreen', 'indianred', 'crimson', 'darkgreen', 'mediumslateblue', 'mediumseagreen', 'grey', 'brown', 'magenta', 'mediumaquamarine', 'pink', 'orangered', 'lightcoral', 'lightgoldenrodyellow', 'aquamarine', 'darkorange', 'lightseagreen', 'dimgrey', 'sandybrown', 'lightpink', 'gray', 'yellowgreen', 'lightgrey', 'papayawhip', 'rosybrown', 'gold', 'olive', 'white', 'orchid', 'teal', 'lightblue', 'mediumblue', 'plum', 'darkcyan', 'mistyrose', 'darkviolet', 'lightgray', 'mintcream', 'dimgray', 'greenyellow', 'paleturquoise', 'darkgoldenrod', 'tan', 'lightskyblue', 'navy', 'silver', 'goldenrod', 'peachpuff', 'ghostwhite', 'salmon', 'palevioletred', 'beige', 'indigo', 'lightyellow', 'cornflowerblue', 'linen', 'lightsalmon', 'slategrey', 'cyan', 'lightslategrey', 'royalblue', 'palegreen', 'seagreen', 'darkseagreen', 'slategray', 'lawngreen', 'lemonchiffon', 'lightslategray', 'seashell', 'khaki', 'mediumvioletred', 'olivedrab', 'moccasin', 'mediumorchid', 'midnightblue', 'darkgrey', 'darkolivegreen', 'black', 'honeydew', 'maroon', 'lime', 'darkslategray', 'whitesmoke', 'bisque', 'burlywood', 'darkred', 'slateblue', 'darkturquoise', 'limegreen', 'purple', 'darkorchid', 'thistle', 'aliceblue', 'wheat', 'rebeccapurple', 'darksalmon', 'mediumturquoise', 'hotpink', 'cadetblue', 'ivory', 'cornsilk', 'lightcyan', 'blueviolet', 'firebrick', 'navajowhite', 'antiquewhite', 'sienna', 'mediumspringgreen', 'chocolate', 'snow', 'oldlace', 'fuchsia', 'aqua', 'yellow', 'coral', 'deeppink', 'palegoldenrod', 'tomato', 'darkkhaki', 'darkmagenta']

    #colors = 1000 * colors
    colors = [ 'black' , 'red', 'yellow', 'purple', 'violet', 'blue',
               'brown', 'green', 'aqua', 'orange',
               'lime', 'darkred', 'dimgray', 'olive', 'mediumpurple',
               'sandybrown', 'teal'] + colorsm
    colrs = [colors[i] for i in range(rangeend-rangestart)]


    if (P == 2):

        ## 2D reduction
        pca = PCA(n_components=2)

        #print(X)

        X_pca = pca.fit_transform(X)

        if (remOut):
            # removing outliers
            xmean = np.mean(X_pca[:, 0])
            xsd = np.std(X_pca[:, 0])
            ymean = np.mean(X_pca[:, 1])
            ysd = np.std(X_pca[:, 1])
            x = [vec[0] for vec in X_pca if (not isOut(vec[0], xmean, xsd) and not isOut(vec[1], ymean, ysd))]
            y = [vec[1] for vec in X_pca if (not isOut(vec[0], xmean, xsd) and not isOut(vec[1], ymean, ysd))]
            b = [(not isOut(vec[0], xmean, xsd) and not isOut(vec[1], ymean, ysd)) for vec in X_pca]
            label = lab[b]



            # printing only 10 clusters (not first 10 largest)
            if (local):
                ldict = {}
                for lab in label:
                    if lab in ldict:
                        ldict[lab] += 1
                    else:
                        ldict[lab] = 1

                s = sorted(ldict.items(), key=lambda  kv: kv[1], reverse=True)
                take10 = [s[i][0] for i in range(rangestart, rangeend)] #10 labelov
                my10 = [i in take10 for i in label]
                x = [x[i] for i in range(0, len(my10)) if my10[i]]
                y = [y[i] for i in range(0, len(my10)) if my10[i]]
                label = label[my10]

                #printing sizes of clusters

                clustersSizes = [s[i][1] for i in range(len(ldict))]

                g = open('sizes.txt', 'w')
                for size in clustersSizes:
                    g.write(str(size) + '\n')
                g.close()


        else:
            x = [vec[0] for vec in X_pca]
            y = [vec[1] for vec in X_pca]
            label = lab



        fig = plt.figure()
        plt.title("DBSCAN clusters")
        plt.scatter(x, y, c=label, cmap=matplotlib.colors.ListedColormap(colrs))
        plt.xlabel('PCA component 1')
        plt.ylabel('PCA component 2')
        plt.savefig(d + "PCA_2D_clusters.png")
        #plt.show()


    if (P == 3):
        # ## 3D reduction

        pca = PCA(n_components=3)

        #print(X)

        X_pca = pca.fit_transform(X)

        if (remOut):
            # removing outliers
            xmean = np.mean(X_pca[:, 0])
            xsd = np.std(X_pca[:, 0])
            ymean = np.mean(X_pca[:, 1])
            ysd = np.std(X_pca[:, 1])
            zmean = np.mean(X_pca[:, 2])
            zsd = np.std(X_pca[:, 2])

            x = [vec[0] for vec in X_pca if (not isOut(vec[0], xmean, xsd) and not isOut(vec[1], ymean, ysd) and not isOut(vec[2], ymean, ysd) )]
            y = [vec[1] for vec in X_pca if (not isOut(vec[0], xmean, xsd) and not isOut(vec[1], ymean, ysd) and not isOut(vec[2], ymean, ysd) )]
            z = [vec[2] for vec in X_pca if (not isOut(vec[0], xmean, xsd) and not isOut(vec[1], ymean, ysd) and not isOut(vec[2], ymean, ysd) )]
            b = [(not isOut(vec[0], xmean, xsd) and not isOut(vec[1], ymean, ysd) and not isOut(vec[2], ymean, ysd) ) for vec in X_pca]
            label = lab[b]



            # printing only 10 clusters (not first 10 largest)
            if (local):
                ldict = {}
                for lab in label:
                    if lab in ldict:
                        ldict[lab] += 1
                    else:
                        ldict[lab] = 1

                s = sorted(ldict.items(), key=lambda  kv: kv[1], reverse=True)
                take10 = [s[i][0] for i in range(rangestart, rangeend)] #10 labelov
                my10 = [i in take10 for i in label]
                x = [x[i] for i in range(0, len(my10)) if my10[i]]
                y = [y[i] for i in range(0, len(my10)) if my10[i]]
                z = [z[i] for i in range(0, len(my10)) if my10[i]]
                label = label[my10]

                #printing sizes of clusters

                clustersSizes = [s[i][1] for i in range(len(ldict))]

                g = open('sizes.txt', 'w')
                for size in clustersSizes:
                    g.write(str(size) + '\n')
                g.close()


        else:
            x = [vec[0] for vec in X_pca]
            y = [vec[1] for vec in X_pca]
            label = lab



        fig = plt.figure()
        plt.title("DBSCAN clusters")
        plt.scatter(x, y, z, c=label, cmap=matplotlib.colors.ListedColormap(colrs))
        plt.xlabel('PCA component 1')
        plt.ylabel('PCA component 2')
        plt.savefig("PCA_2D_clusters.png")


    # pca3 = PCA(n_components=3)
    # X_pca3 = pca3.fit_transform(X)
    #
    # x = [vec[0] for vec in X_pca3]
    # y = [vec[1] for vec in X_pca3]
    # z = [vec[2] for vec in X_pca3]
    #
    # label = clst.labels_
    # fig = plt.figure()
    # plt.scatter(x, y, c=label, cmap=matplotlib.colors.ListedColormap(colrs))
    # plt.show()


    #print(clusters)

