
import argparse
parser = argparse.ArgumentParser()
parser.add_argument("--fname", default='ResfinEps1/results25_6', help="echo the string you use here")
args = parser.parse_args()

filename = args.fname

from matplotlib import pyplot as plt
import os
import numpy as np



def getName(subject): #ResultsC
    a = str(subject[len('ResultsC'):-(len('_L001.pkl'))])
    i = a.find('/')

    a = a[i + 1:]
    i = a.find('_')

    return a[i + 1:]

#need to contain 5 and 6 element
def processFile(filename): #returns percent of unimportant reads
    percentage = []

    nor = 0

    subjects = []

    f = open(filename)

    for l in f:  # cummulate error
        nor += 1
        line = l.split()
        subjects.append(getName(line[0]))
        #numS / numAll
        percentage.append( float(line[6]) / (float(line[6]) + float(line[7])))

    f.close()

    print(subjects)

    return [percentage, nor, subjects]


[percentage, numfiles, subjects] = processFile(filename)


height = [p * 100 for p in percentage]
bars = [i for i in range(len(subjects))]
y_pos = np.arange(len(bars))

colors = ['black' , 'red', 'yellow', 'purple', 'violet', 'blue', 'brown', 'green', 'aqua', 'orange', 'lime']

a = plt.figure()                # the first figure figsize=(6, 8)


#a.suptitle('Histogram of the unimportant reads', fontsize=14, ha='right')


b = plt.subplot(111)             # the first subplot in the first figure

#plt.bar(y_pos, height, color=('r', 'g', 'b', 'y', 'black', 'pink', 'lime', 'brown'))


for i in range(len(subjects)):
    plt.bar(i, height[i], width=0.6, color=colors[i],  label=subjects[i],align="center")
# top_ax.bar([0.5, 1.5, 2.5], [0.3, 0.2, 0.2], color="red", width=0.4,
#            label="Bar 2", align="center")
plt.legend(loc=4)


plt.xticks(y_pos, bars)
plt.title('The important reads rate', fontsize=14, ha='right')

# start, end = b.get_ylim()
# b.yaxis.set_ticks(np.arange(start, end, 0.005*100))

plt.xlabel('subjects')
plt.ylabel('reads marked important [%]')

#a.legend(subjects, loc=1)

a.tight_layout()
a.tight_layout()
plt.subplots_adjust(top=0.92)
plt.subplots_adjust(left=0.15)




plt.savefig("histogram_.png")

plt.show()





