
#plot error N2 for all files


from matplotlib import pyplot as plt

import os
import numpy as np
import math

error3pos = 4

def m(x, sqt = True):
    if sqt:
        return math.sqrt(x)
    else:
        return x


def getName(subject): #ResultsC
    a = str(subject[len('ResultsC'):-(len('_L001.pkl'))])
    i = a.find('/')

    a = a[i+1:]
    i = a.find('_')

    return a[i+1:]

def processFile(filename): #returns averaged normalized error
    global error3pos
    N1 = []
    N2 = []
    N3 = []

    nor = 0

    subjects = []

    f = open(filename)

    for l in f:  # cummulate error
        nor += 1
        line = l.split()
        subjects.append(getName(line[0]))
        N1.append(m(float(line[1])))
        N2.append(m(float(line[2])))
        N3.append(float(line[error3pos]))

    f.close()

    return [N1, N2, N3, nor, subjects]

def getEps(filename):
    idx = filename.find('_')
    return int(filename[idx+1:])


def sortL(eps, N):
    zp = zip(eps, N)
    return [x for _, x in sorted(zp)]

print(getName('ResultsC25_6/FANCI-30-APH_S6_L001.pkl'))


N = []
eps = []

d = 1
datasada = 'ResfinEps' + str(d)

fnames = os.listdir(datasada)

for fname in fnames:
    filename = datasada + '/' + fname

#filename = 'results25_6'
    Nt = processFile(filename)
    numfiles = Nt[3]
    subjects = Nt[4]
    Nt = Nt[0:3]
    epstmp = getEps(filename)

    N.append(Nt)
    eps.append(epstmp)

N = sortL(eps, N)
eps.sort()

N1s = [n[0] for n in N]
N2s = [n[1] for n in N]
N3s = [n[2] for n in N]

print(N1s)
print(N2s)
print(N3s)
print(eps)



colors = ['black' , 'red', 'yellow', 'purple', 'violet', 'blue', 'brown', 'green', 'aqua', 'orange', 'lime']

a = plt.figure(figsize=(6,6))                # the first figure figsize=(6, 8)


a.suptitle('The error N2 in the dataset '+ str(d), fontsize=14, ha='right')


b = plt.subplot(111)             # the first subplot in the first figure

print(N1s)
leg = []

for i in range(numfiles):
    y = [n[i] for n in N2s]
    l = plt.scatter(eps, y, c=colors[i])
    leg.append(l)

#b.set_ylim(ymin=0)

start, end = b.get_ylim()
b.yaxis.set_ticks(np.arange(start, end, 0.005))

plt.xlabel('eps')
plt.ylabel('N2')


a.legend(leg, subjects, loc=1)

a.tight_layout()
plt.subplots_adjust(top=0.92)



plt.savefig("N2-eps" + str(d)+ ".png")

plt.show()

