
#plot average errors
#OK

import math

from matplotlib import pyplot as plt

import os
import numpy as np
error3pos = 4

def m(x, sqt = True):
    if sqt:
        return math.sqrt(x)
    else:
        return x

def processFile(filename): #returns averaged normalized error
    global error3pos
    N1 = N2 = N3 = nor = 0

    f = open(filename)

    for l in f:  # cummulate error
        nor += 1
        line = l.split()
        N1 += m((float(line[1])))
        N2 += m((float(line[2])))
        N3 += float(line[error3pos]) * float(line[7])

    N1 = N1 / nor
    N2 = N2 / nor
    N3 = N3 / nor

    f.close()

    return [N1, N2, N3]

def getEps(filename):
    idx = filename.find('_')
    return int(filename[idx+1:])


def sortL(eps, N):
    zp = zip(eps, N)
    return [x for _, x in sorted(zp)]




N = []
eps = []

d = 2
datasada = 'ResfinEps' + str(d)



fnames = os.listdir(datasada)

for fname in fnames:
    filename = datasada + '/' + fname

#filename = 'results25_6'
    Nt = processFile(filename)
    epstmp = getEps(filename)

    N.append(Nt)
    eps.append(epstmp)

N = sortL(eps, N)
eps.sort()

N1 = [n[0] for n in N]
N2 = [n[1] for n in N]
N3 = [n[2] for n in N]

print(N1)
print(N2)
print(N3)
print(eps)


tic = round(0.1 /5, 2)

a = plt.figure(figsize=(5,7))                # the first figure figsize=(6, 8)


a.suptitle('The error in the dataset ' + str(d), fontsize=14)


b = plt.subplot(311)             # the first subplot in the first figure
#b.margins(x=0.1, y=-0.25)
plt.scatter(eps, [n for n in N1], c='violet')
#plt.scatter(eps, [n for n in N2], c='lime')
#b.set_ylim(ymin=0)

start, end = b.get_ylim()
b.grid()
b.yaxis.set_ticks(np.arange(start, end + (end-start)/10 , tic/2  ))

plt.xlabel('eps')
plt.ylabel('N1')


b = plt.subplot(312)             # the second subplot in the first figure
plt.scatter(eps, [n for n in N2], c='lime')

#b.set_ylim(ymin=0)
start, end = b.get_ylim()
b.grid()
b.yaxis.set_ticks(np.arange(start, end + (end-start)/10, round(end/20,2)))

plt.xlabel('eps')
plt.ylabel('N2')


c = plt.subplot(313)             # the second subplot in the first figure
plt.scatter(eps, [n for n in N3], c='mediumspringgreen')


#c.set_ylim(ymin=0)
start, end = c.get_ylim()
c.grid()
print(end)
c.yaxis.set_ticks(np.arange(start, end + (end-start)/10 , round((end-start)/5, 2)))

plt.xlabel('eps')
plt.ylabel('N3')


a.tight_layout()
plt.subplots_adjust(top=0.92)



plt.savefig("N-eps" + str(d) + ".png")

plt.show()





a = [2,1,0,4,5]
b = ['c', 'd', 'e', 'f', 'g']

print(sortL(a,b))





