
#plot average errors

from matplotlib import pyplot as plt

import os
import numpy as np

import math

error3pos = 4

def m(x, sqt = True):
    if sqt:
        return math.sqrt(x)
    else:
        return x

def processFile(filename): #returns averaged normalized error
    global error3pos
    N1 = N2 = N3 = nor = 0

    f = open(filename)

    for l in f:  # cummulate error
        nor += 1
        line = l.split()
        N1 += m(float(line[1]))
        N2 += m(float(line[2]))
        N3 += float(line[error3pos]) * float(line[7])

    N1 = N1 / nor
    N2 = N2 / nor
    N3 = N3 / nor

    f.close()

    return [N1, N2, N3]

def getK(filename):
    idx = filename.find('_')
    return int(filename[idx-2:idx])


def sortL(eps, N):
    zp = zip(eps, N)
    return [x for _, x in sorted(zp)]



consEps = 6

N = []
eps = []

d = 2

if (consEps == 6):
    datasada = 'ResfinK' + str(d) #for eps 6
elif(consEps == 9):
    datasada = 'Resfin9K' + str(d) #for eps 9



fnames = os.listdir(datasada)

for fname in fnames:
    filename = datasada + '/' + fname

#filename = 'results25_6'
    Nt = processFile(filename)
    epstmp = getK(filename)

    N.append(Nt)
    eps.append(epstmp)

N = sortL(eps, N)
eps.sort()

N1 = [n[0] for n in N]
N2 = [n[1] for n in N]
N3 = [n[2] for n in N]

print(N1)
print(N2)
print(N3)
print(eps)


# f, (ax1, ax2) = plt.subplots(2, 1)
# f.tight_layout()
#
# f.suptitle('Hello')
#
# b = ax1.scatter(eps, N1, c='violet')
# ax1.set_xlabel('eps')
# ax1.set_ylabel('N1')
#
# ax2.scatter(eps, N1, c='violet')
# ax2.set_xlabel('eps1')
# ax2.set_ylabel('N2')


#f.tight_layout()
tic = round(0.1 /5, 2)

a = plt.figure(figsize=(5,7))                # the first figure figsize=(6, 8)


a.suptitle('The error in the dataset ' + str(d), fontsize=14)


b = plt.subplot(311)             # the first subplot in the first figure
#b.margins(x=0.1, y=-0.25)
plt.scatter(eps, [n for n in N1], c='violet')
#plt.scatter(eps, [n for n in N2], c='lime')
#b.set_ylim(ymin=0)

start, end = b.get_ylim()
b.grid()
b.yaxis.set_ticks(np.arange(start, end + (end-start)/20 , tic/2  ))

plt.xlabel('eps')
plt.ylabel('N1')


b = plt.subplot(312)             # the second subplot in the first figure
plt.scatter(eps, [n for n in N2], c='lime')

#b.set_ylim(ymin=0)
start, end = b.get_ylim()
b.grid()
b.yaxis.set_ticks(np.arange(start, end + (end-start)/10, round(end/10,2)))

plt.xlabel('eps')
plt.ylabel('N2')


c = plt.subplot(313)             # the second subplot in the first figure
plt.scatter(eps, [n for n in N3], c='mediumspringgreen')


#c.set_ylim(ymin=0)
start, end = c.get_ylim()
c.grid()
print(end)
c.yaxis.set_ticks(np.arange(start, end + (end-start)/10 , round((end-start)/5, 2)))

plt.xlabel('eps')
plt.ylabel('N3')


a.tight_layout()
plt.subplots_adjust(top=0.92)



plt.savefig("N-k" + str(d) + ".png")

plt.show()

