"""
2.step

joins the k-mer counts from jellyfish into the table

Parameters : –restable (result table name)
Input : Folder with the output of jellyfish
Output : table.txt

"""
# takes jellyfish output (dump files) and merges them into table

import os

import argparse
parser = argparse.ArgumentParser()
parser.add_argument("--restable", default='table.txt', help="echo the string you use here")
args = parser.parse_args()


dataDirectory = 'Data'
resFile = args.restable
lowerBound = 10


fileDir = os.path.dirname(os.path.realpath('__file__'))
dataDirFiles = os.path.join(fileDir, dataDirectory)
files = sorted(os.listdir(dataDirFiles))

myDict = {}

fileNo = 0

#creating table
for file in files:

    inputFile = os.path.join(dataDirectory, file)
    f = open(inputFile)

    m = 0
    while True:
        m+=1
        try:
            count = f.readline().split('>')
            count = int(count[1])
            seq = f.readline().rstrip('\n')

            if (True) : #(count > lowerBound to change funcionality if wanted)
                savedVal = myDict.get(seq)
                if (savedVal == None):
                    myDict[seq] = [0 for i in range(fileNo)] + [count]
                else:
                    for _ in range(fileNo - len(savedVal)):
                        savedVal.append(0)
                    savedVal.append(count)
        except:
            break
    fileNo += 1
    print("file processed")
    f.close()

#padding

for val in myDict.values():
    for _ in range(fileNo - len(val)):
        val.append(0)

#saving results
f = open(resFile, "w")
f.write(str(files) + '\n\n')

for item, val in myDict.items():

    val = [val[i] + val[i + 1] for i in range(0, len(val) - 1, 2)]  # merges R1 and R2 columns (next to each other)

    if any([i > lowerBound for i in val]):  # True
        f.write(item + ' ' + str(val) + '\n')

f.close()

