
"""
1.step

generates a script that runs jellyfish on all input files

Parameters: –datadir (path to the input data folder) 
            –ksize (k-mer length)
Input : folder containing R1 and R2 files for each subject
Output: script ( .sh ) that runs jellyfish on input data using 4 threads and saves
results to Results folder, each input file name with corresponding output-file
name. Each output file contains k-mers present in the input file with its count.

"""

import os

import argparse
parser = argparse.ArgumentParser()
parser.add_argument("--ksize", default=25, help="echo the string you use here")
parser.add_argument("--datadir", default='data')
args = parser.parse_args()

kmer_size = int(args.ksize)
filename = "my_generate_counts_commands" + str(kmer_size) + ".sh"

def nameToFa(filename):
    p = filename.split(".")
    res = p[0] + ".fa"
    return res

fastaP = args.datadir # 'data'
fastaPath = fastaP + '/'  #'data/'
resultDir = 'myResults/'



fileDir = os.path.dirname(os.path.realpath('__file__'))
dataDirFiles = os.path.join(fileDir, fastaP)

files = os.listdir(dataDirFiles)


f = open(filename, "w")

f.write('#! /bin/bash\n')


for file in files:

    command1 =  './bin/jellyfish count -m ' + str(kmer_size) + ' -C -s 100M --bf-size 3G -t 4 <' '(zcat ' + fastaPath + file + ' )'
    command2 = './bin/jellyfish  dump  mer_counts.jf   > ' + resultDir + str(kmer_size) + 'mer_counts_dump_' + nameToFa(file)
    command3 = 'echo ' + '\"'  + file + ' processed' + '\"'

    f.write(command1 + "\n")
    f.write(command2 + "\n\n")
    f.write(command3 + "\n\n")


f.close()
